"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var store_1 = require("../data/store");
var _constants_1 = require("../constants");
var directives_1 = require("../utilities/directives");
var containers_1 = require("../utilities/containers");
var declarations_1 = require("./declarations");
exports.parseRules = function (css) {
    containers_1.walkContainer(css, [_constants_1.RULE_TYPE], true, function (node, containerDirectives) {
        var rule = node;
        var RENAME = containerDirectives[_constants_1.CONTROL_DIRECTIVE.RENAME];
        if (RENAME && RENAME.directive) {
            var block = RENAME.block;
            directives_1.resetDirective(RENAME);
            if (block !== _constants_1.CONTROL_DIRECTIVE_BLOCK.END) {
                store_1.store.rulesAutoRename.push(rule);
                declarations_1.parseDeclarations(rule, true);
            }
            else {
                declarations_1.parseDeclarations(rule);
            }
        }
        else {
            declarations_1.parseDeclarations(rule);
        }
    });
};
