"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var _constants_1 = require("../constants");
var directives_1 = require("./directives");
var rules_1 = require("./rules");
exports.walkContainer = function (container, filter, removeComments, callback) {
    var controlDirective;
    var containerDirectives = {};
    container.each(function (node) {
        if (node.type !== _constants_1.COMMENT_TYPE && !filter.includes(node.type))
            return;
        if (node.type === _constants_1.COMMENT_TYPE) {
            var comment = node;
            controlDirective = directives_1.getControlDirective(comment);
            if (controlDirective) {
                if (removeComments) {
                    rules_1.cleanRuleRawsBefore(comment.next());
                    comment.remove();
                }
                containerDirectives[controlDirective.directive] = __assign({}, controlDirective);
                controlDirective = null;
                return;
            }
        }
        else {
            var IGNORE = containerDirectives[_constants_1.CONTROL_DIRECTIVE.IGNORE];
            if (IGNORE && IGNORE.directive) {
                var block = IGNORE.block;
                directives_1.resetDirective(IGNORE);
                if (block !== _constants_1.CONTROL_DIRECTIVE_BLOCK.END) {
                    return;
                }
            }
            callback(node, containerDirectives);
        }
    });
};
