"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _constants_1 = require("../constants");
var CONTROL_DIRECTIVE_VALUES = Object.values(_constants_1.CONTROL_DIRECTIVE);
var CONTROL_DIRECTIVE_BLOCK_VALUES = Object.values(_constants_1.CONTROL_DIRECTIVE_BLOCK);
exports.isValidMatchDirective = function (match) {
    return CONTROL_DIRECTIVE_VALUES.includes("" + match[2]) &&
        (match[1] === undefined ||
            CONTROL_DIRECTIVE_BLOCK_VALUES.includes("" + match[1]));
};
exports.getControlDirective = function (comment) {
    var commentStr = comment.toString();
    var match = commentStr.match(_constants_1.RTL_CONTROL_DIRECTIVE_REG_EXP);
    if (match && exports.isValidMatchDirective(match)) {
        var controlDirective = {
            directive: match[2]
        };
        if (match[1]) {
            controlDirective.block = match[1];
        }
        return controlDirective;
    }
    return null;
};
exports.resetDirective = function (directive) {
    if (directive.block === _constants_1.CONTROL_DIRECTIVE_BLOCK.END) {
        directive.directive = null;
        directive.block = null;
    }
    else {
        if (directive.block !== _constants_1.CONTROL_DIRECTIVE_BLOCK.BEGIN) {
            directive.directive = null;
            directive.block = null;
        }
    }
};
